import andisdk
from andiutils import message_builder, andi, target_ecu
import System
import time
import logging
from TestRunner.UnitTest.case import Severity
from time import sleep
from itertools import count
import os
from pickle import FALSE
from subprocess import Popen, PIPE
from andisdk import NetworkProtocols, TransportProtocols,PtpMessageTypes,EtherType, MessageICMPv6
from time import sleep
from os import system, getpgid
import sys
import traceback
from numpy import True_, true_divide

from Tests.test_base import TestBase

from andiutils import message_builder, andi, target_ecu
from threading import Thread
from TestRunner.UnitTest.case import Severity
import logging
from controllers.diagnostic_jobs.udscontroller import UdsController
import ipaddress
from andisdk.uds import UdsClient, DoIpConnection
from udsoncan import DidCodec, Dtc
import json
from andisdk.filters import pcap_filter
from Utilities_Common.OutputPathManager import OutputPathManager
import re
from fileinput import close
from andiutils import close_client, get_client
from tediagtoolbox.diag_manager import DiagManager

from technica_simulator.model.simulation_description import SimulationDescription
from technica_simulator.api_manager import create_pdu_message
from andisdk import NetworkProtocols
from technica_simulator.message_cyclic_simulator import MessageCyclicGenerator

class timesync_base(TestBase):
    ###############.....Utilites for starting/stoping PTP ......####################################
#<-Master->
    
    ptp4lExePath = "/usr/sbin/ptp4l"
    ptp4lConfig_master = "/etc/linuxptp/automotive-master.cfg" 
    ptp4lConfig_master_inhibit_announce_disabled = "/etc/linuxptp/automotive-master_inhibit_announce_disabled.cfg"
    interface_master = "sim_1"
    interfaceLogging = ""
    pgidPtp4lProcessMaster = 0
    #<-Slave->
    #ptp4lConfig_slave = "testslinux_ptp_config/automotive-slave.cfg"
    ptp4lConfig_slave = "/etc/linuxptp/automotive-slave.cfg"
    #ptp4lConfig_slave_24 = "/etc/linuxptp/automotive-slave-24.cfg"
    ptp4lConfig_slave_24 = "/etc/linuxptp/automotive-slave-24.cfg"
    ptp4lConfig_slave_operLogSyncInterval_0 = "tests/linux_ptp_config/automotive-slave_operLogSyncInterval_0.cfg"
    ptp4lConfig_slave_operLogSyncInterval_2 = "tests/linux_ptp_config/automotive-slave_operLogSyncInterval_2.cfg"
    ptp4lConfig_slavedelaymechanism = "/etc/linuxptp/automotive-slave_delaymechanism.cfg"
    ptp4lConfig_slave_UDPipv4 = "linux_ptp_config/automotive-slave_UDPipv4.cfg"
    ptp4lConfig_master_UDPipv4 = "linux_ptp_config/automotive-master_UDPipv4.cfg"
    ptp4lConfig_master_error_dst = "tests/linux_ptp_config/automotive-master-mac-dst-err.cfg"
    #ptp4lConfig_master_error_dst = "tests/linux_ptp_config/automotive-master.cfg"
    ptp4lConfig_master_Inhibit_delay_req_disabled = "tests/linux_ptp_config/automotive-master-Inhibit_delay_req_disabled.cfg"
    ptp4lConfig_slave_Inhibit_delay_req_disabled = "tests/linux_ptp_config/automotive-slaver-Inhibit_delay_req_disabled.cfg"

    interface_slave = "sim_4"
    interfaceLogging = ""
    pgidPtp4lProcessSlave = 0

    crc8H2F_tab =  [0x0, 0x2f, 0x5e, 0x71, 0xbc, 0x93, 0xe2, 0xcd,0x57, 0x78, 0x9, 0x26, 0xeb, 0xc4, 0xb5, 0x9a,0xae, 0x81, 0xf0, 0xdf, 0x12, 0x3d, 0x4c, 0x63,0xf9, 0xd6, 0xa7, 0x88, 0x45, 0x6a, 0x1b, 0x34,0x73, 0x5c, 0x2d, 0x2, 0xcf, 0xe0, 0x91, 0xbe,0x24, 0xb, 0x7a, 0x55, 0x98, 0xb7, 0xc6, 0xe9,0xdd, 0xf2, 0x83, 0xac, 0x61, 0x4e, 0x3f, 0x10,0x8a, 0xa5, 0xd4, 0xfb, 0x36, 0x19, 0x68, 0x47,0xe6, 0xc9, 0xb8, 0x97, 0x5a, 0x75, 0x4, 0x2b,0xb1, 0x9e, 0xef, 0xc0, 0xd, 0x22, 0x53, 0x7c,0x48, 0x67, 0x16, 0x39, 0xf4, 0xdb, 0xaa, 0x85,0x1f, 0x30, 0x41, 0x6e, 0xa3, 0x8c, 0xfd, 0xd2,0x95, 0xba, 0xcb, 0xe4, 0x29, 0x6, 0x77, 0x58,0xc2, 0xed, 0x9c, 0xb3, 0x7e, 0x51, 0x20, 0xf,0x3b, 0x14, 0x65, 0x4a, 0x87, 0xa8, 0xd9, 0xf6,0x6c, 0x43, 0x32, 0x1d, 0xd0, 0xff, 0x8e, 0xa1,0xe3, 0xcc, 0xbd, 0x92, 0x5f, 0x70, 0x1, 0x2e,0xb4, 0x9b, 0xea, 0xc5, 0x8, 0x27, 0x56, 0x79,0x4d, 0x62, 0x13, 0x3c, 0xf1, 0xde, 0xaf, 0x80,0x1a, 0x35, 0x44, 0x6b, 0xa6, 0x89, 0xf8, 0xd7,0x90, 0xbf, 0xce, 0xe1, 0x2c, 0x3, 0x72, 0x5d,0xc7, 0xe8, 0x99, 0xb6, 0x7b, 0x54, 0x25, 0xa,0x3e, 0x11, 0x60, 0x4f, 0x82, 0xad, 0xdc, 0xf3,0x69, 0x46, 0x37, 0x18, 0xd5, 0xfa, 0x8b, 0xa4,0x5, 0x2a, 0x5b, 0x74, 0xb9, 0x96, 0xe7, 0xc8,0x52, 0x7d, 0xc, 0x23, 0xee, 0xc1, 0xb0, 0x9f,0xab, 0x84, 0xf5, 0xda, 0x17, 0x38, 0x49, 0x66,0xfc, 0xd3, 0xa2, 0x8d, 0x40, 0x6f, 0x1e, 0x31,0x76, 0x59, 0x28, 0x7, 0xca, 0xe5, 0x94, 0xbb,0x21, 0xe, 0x7f, 0x50, 0x9d, 0xb2, 0xc3, 0xec,0xd8, 0xf7, 0x86, 0xa9, 0x64, 0x4b, 0x3a, 0x15,0x8f, 0xa0, 0xd1, 0xfe, 0x33, 0x1c, 0x6d, 0x42]
    clampControlDataIdList = [0x63,0xb6,0x16,0x88,0xac,0x40,0xcc,0x19,0xf6,0x7b,0x29,0xd2,0x9d,0x27,0xd5,0xdf]
    #KST_KL_15 = 0x02 #byte 3 bit 1 set
    KST_KL_15 = 0x03 #byte 3 bit 1 set
    test = [0x00, 0x00, KST_KL_15, 0x00, 0x00, 0x00, 0x00, 0x00]#data with CRC field 0x00
    clampcontrol_payload = [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00]
    clampcontrol_pdu_len = [0x00,0x00,0x01,0xFA,0x00,0x00,0x00,0x08]

    #ClampControl_01 = message_builder.create_pdu_message("sim_1","logs")
    ClampControl_01 = message_builder.create_pdu_message("sim_3","logs")
    #ClampControl_01.ethernet_header.mac_address_destination = "02:7d:fa:00:b3:00"
    ClampControl_01.ethernet_header.mac_address_destination = target_ecu.mac_address_dest
    #ClampControl_01.ethernet_header.mac_address_source = "02:7d:fa:00:10:01"
    ClampControl_01.ethernet_header.mac_address_source = target_ecu.mac_address_source
    ClampControl_01.network_protocol = NetworkProtocols.IPv6
    ClampControl_01.ipv6_header.ip_address_destination = "ff14::3a"
    ClampControl_01.ipv6_header.ip_address_source = "fd53:7cb8:383:5::e"
    ClampControl_01.transport_header.port_destination = 42557
    ClampControl_01.transport_header.port_source = 42994
    ClampControl_01.vlan_tag.inner_vlan = 2
    ClampControl_01.message_id = 0x1FA
    ClampControl_01.length = 8
    alive = -1
    

    def CalculateProfile2(self,payload, alive, challengeSeq):
        payload[1] = ((payload[1] & 0xF0) | (alive & 0x0F))
        dataId = challengeSeq[alive]
        crc = 0xFF
        for counter in range(1, len(payload )):
            crc = self.crc8H2F_tab[crc ^ payload[counter]]
        crc = self.crc8H2F_tab[crc ^ dataId]
        crc = crc ^ 0xFF
        payload[0] = crc
        return payload
    def calculate_CRC_payload(self):
        crc = self.CalculateProfile2(self.test, self.alive, self.clampControlDataIdList) #calculate CRC
        payload = bytearray.fromhex(''.join('{:02x} '.format(x) for x in self.test))  
        return payload

    def set_KST_KL_15(self):
        global KST_KL_15
        KST_KL_15 = (KST_KL_15 | 0x02) #byte 3 bit 1 set

    def clear_KST_KL_15(self):
        global KST_KL_15
        KST_KL_15 = (KST_KL_15 & 0x00) #byte 3 bit 1 clear

    def get_alive_counter(self):
        self.alive = (self.alive + 1) % 16
        return self.alive
    
    def send_ClampControl_01(self):
        if target_ecu.name == "HCP2" or target_ecu.name == "HCP1" :
           self.test[1] = self.get_alive_counter()
           self.test[2] = (self.test[2] & 0xFD) | self.KST_KL_15
           payload = tuple(self.calculate_CRC_payload())
           self.ClampControl_01.payload = tuple(payload)
           self.ClampControl_01.send()
        
    
    def generate_SystemInfo_01(self):
        
        if target_ecu.name == "HCP1":
           sys_info_msg = message_builder.create_pdu_message(target_ecu.masterInterface,"logs")
           sys_info_msg.ethernet_header.mac_address_destination = "33:33:00:00:00:49"
           sys_info_msg.ethernet_header.mac_address_source = "02:7d:fa:00:10:01"
           sys_info_msg.network_protocol = NetworkProtocols.IPv6
           sys_info_msg.ipv6_header.ip_address_destination = "ff14::49"
           sys_info_msg.ipv6_header.ip_address_source = "fd53:7cb8:383:5::1:1e6"
           sys_info_msg.transport_header.port_destination = 42557
           sys_info_msg.transport_header.port_source = 42994
           sys_info_msg.vlan_tag.inner_vlan = 2
           sys_info_msg.message_id = 0x1
           sys_info_msg.length = 8
           sys_info_msg.payload =(bytearray.fromhex('000c008000000000'))
           #self.sys_info_msg.send()
           return MessageCyclicGenerator(sys_info_msg, cycle=1)
            
            
    def send_SystemInfo_01(self):
        if target_ecu.name == "HCP3":
            Systeminfo_01 = message_builder.create_can_message(
            target_ecu.WU_CAN_id_Comp, target_ecu.WU_CAN_id_Comp)
            Systeminfo_01.can_header.message_id = 0x585
            Systeminfo_01.payload =(bytearray.fromhex(
            'c00c008000000000'))
            Systeminfo_01.send()
            
        if target_ecu.name == "PASD" or target_ecu.name == "MRR" or target_ecu.name == "MFK_5" or target_ecu.name == "HCP1":
            Systeminfo_01 = message_builder.create_can_message(
            target_ecu.WU_CAN_id_Comp, target_ecu.WU_CAN_id_Comp)
            Systeminfo_01.can_header.message_id = 0x585
            #Systeminfo_01.payload =(bytearray.fromhex(
            #'c00c008000000000'))
            Systeminfo_01.payload =(bytearray.fromhex(
            '000c008000000000'))
            Systeminfo_01.send()    
    
    def on_time_elapsed(self, timer, event):
        self.send_CAN_wakeup()
       
        if(target_ecu.name=="HCP3"):
            self.send_SystemInfo_01()
            sleep(0.2)
            self.send_SystemInfo_01_eth()
            
        if target_ecu.name=="PASD" or target_ecu.name == "MRR" or target_ecu.name == "MFK_5" or target_ecu.name == "HCP1":
            self.send_SystemInfo_01()
            sleep(0.2)
            self.send_SystemInfo_01_eth()    
    
        if(target_ecu.name=="HCP2") or (target_ecu.name=="HCP1") :
            self.send_ClampControl_01()

       

    def send_CAN_wakeup(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "MFK_5" or target_ecu.name == "HCP2"or target_ecu.name == "HCP4" or target_ecu.name == "PASD" or target_ecu.name == "MRR" or target_ecu.name == "NR1"  or target_ecu.name == "NR2"  or target_ecu.name == "NR3" or target_ecu.name == "NR4"   or target_ecu.name == "ConMOD" or target_ecu.name == "LRR" or target_ecu.name == "MRR" or target_ecu.name == "HCP1":
            NM_Gateway_CAN_msg = message_builder.create_can_message(
            target_ecu.WU_CAN_id_Comp,  target_ecu.WU_CAN_id_Comp)
            NM_Gateway_CAN_msg.can_header.message_id = 0x1B000010
            NM_Gateway_CAN_msg.payload =(bytearray.fromhex(
            '50FFFFFFFFFFFFFF000000000000000010000402FF000000'))
            NM_Gateway_CAN_msg.send()
    
    def start_cyclic_messages(self):
        self.timer = andi.create_timer()
        self.timer.interval = 100
        self.timer.on_time_elapsed += self.on_time_elapsed
        self.timer.start()
        self.send_CAN_wakeup()
        sleep(0.2)
        self.send_SystemInfo_01()
        sleep(0.2)
        self.send_SystemInfo_01_eth()
        sleep(0.2)
        self.send_ClampControl_01()
        sleep(0.2)
        #self.generate_SystemInfo_01()
        
        
       


    def stop_NM_messages_cyclic(self):
        self.timer.stop
    
    SystemInfo_01 = message_builder.create_pdu_message(target_ecu.masterInterface,"logs")
    SystemInfo_01.ethernet_header.mac_address_destination = "33:33:00:00:00:49"
    SystemInfo_01.ethernet_header.mac_address_source = "02:7d:fa:00:10:01"
    SystemInfo_01.network_protocol = NetworkProtocols.IPv6
    SystemInfo_01.ipv6_header.ip_address_destination = "ff14::49"
    SystemInfo_01.ipv6_header.ip_address_source = "fd53:7cb8:383:5::1:1e6"
    SystemInfo_01.transport_header.port_destination = 42557
    SystemInfo_01.transport_header.port_source = 42994
    #SystemInfo_01.vlan_tag.inner_priority_tag =4
    SystemInfo_01.vlan_tag.inner_vlan = 2
    SystemInfo_01.message_id = 0x1
    SystemInfo_01.length = 8

    def send_SystemInfo_01_eth(self):
        if target_ecu.name == "HCP3":
           self.SystemInfo_01.payload = (bytearray.fromhex('400c008000000000'))
           self.SystemInfo_01.send()
        
        if target_ecu.name == "PASD" or target_ecu.name == "MRR" or target_ecu.name == "MFK_5" or target_ecu.name == "HCP1":
           self.SystemInfo_01.payload = (bytearray.fromhex('400c008000000000'))
           self.SystemInfo_01.send()   
    

    def Start_Master(self):
        
        #system("sudo ptp4l -f /etc/linuxptp/automotive-master.cfg -i sim_1 -m -H -l 6")
        self.ptp4lProcessMaster = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                   stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)
        
    def Start_Master_inhibit_announce_disabled(self):
        self.ptp4lProcessMaster_inhibit_announce_disabled = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master_inhibit_announce_disabled, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                   stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)

    def Start_Slave(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
        
    def Start_Slave_24(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave_24, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)        
    def Start_Slave_Inhibit_delay_req_disabled(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave_Inhibit_delay_req_disabled, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
            
    def Start_TestbenchPC_Master_UDPv4(self):
        self.ptp4lProcessMaster = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master_UDPipv4, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)  
        
    def Start_Slave_modified_syncinterval_0(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave_operLogSyncInterval_0, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
    
    def Start_Slave_modified_syncinterval_2(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave_operLogSyncInterval_2, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
    
    def Start_TestbenchPC_Slave_delaymechanism(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slavedelaymechanism, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
    
    def Start_TestbenchPC_Slave_UDPv4(self):
        self.ptp4lProcessSlave = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_slave_UDPipv4, "-i", target_ecu.slaveInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessSlave = getpgid(self.ptp4lProcessSlave.pid)
        
        
    
    def Start_TestbenchPC_Master_UDPv4(self):
        self.ptp4lProcessMaster = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master_UDPipv4, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                  stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)    
    
    def Start_Master_error_dst(self):
        self.ptp4lProcessMaster = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master_error_dst, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                   stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)
    
    def Start_Master_Inhibit_delay_req_disabled(self):
        self.ptp4lProcessMaster = Popen(["sudo", self.ptp4lExePath, "-f", self.ptp4lConfig_master_Inhibit_delay_req_disabled, "-i", target_ecu.masterInterface, "-m", "-l", "7"],
                                                   stdout=PIPE)
        self.pgidPtp4lProcessMaster = getpgid(self.ptp4lProcessMaster.pid)
        
    def Start_Ptp_inhibit_announce_disabled(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "HCP2" :
            self.ECU_sepecific_preconditions()
            logger.info("Test bench is configured to run as Master ECU (simulated)- to activate the Bridge")
            self.Start_Master_inhibit_announce_disabled()
            logger.info("Test bench is configured to run as slave ECU (simulated)")
            self.Start_Slave()
            
            
    def Start_Ptp(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "HCP2":
            self.ECU_sepecific_preconditions()
            self.Start_Master()
            #self.ECU_sepecific_preconditions()
            logger.info("Test bench is configured to run as Master ECU (simulated)- to activate the Bridge")
            #self.Start_Master()
            logger.info("Test bench is configured to run as slave ECU (simulated)")
            self.Start_Slave()
            
        if target_ecu.name == "HCP5_100"or target_ecu.name == "HCP5_1000" :
            logger.info("Test bench is configured to run as slave ECU (simulated)")
            self.Start_Slave()
        if target_ecu.name == "HCP1"   or target_ecu.name == "HCP4":
            self.Start_Master() #to add new check if the simulation was started successfully.
            self.ECU_sepecific_preconditions() 
            
            #self.Start_Master() #to add new check if the simulation was started successfully.
            logger.info("Master ECU under test is synchronized with slave ECU (simulated)")
            
        if target_ecu.name == "MFK_5":
            #self.ECU_sepecific_preconditions()
            self.Start_Master()
            self.ECU_sepecific_preconditions()
            #os.system("sudo service ptp4l-master-sim_3 start")
            
        if target_ecu.name == "MRR":
            
            self.Start_Master()  
            self.ECU_sepecific_preconditions()
            #self.Start_Master()    
        if target_ecu.name == "ConMOD":
            self.ECU_sepecific_preconditions()    
            self.Start_Master()
            
        if target_ecu.name == "LRR":
            self.Start_Master()
            self.ECU_sepecific_preconditions()    
            #self.Start_Master()
            
        if target_ecu.name == "PASD":
            self.ECU_sepecific_preconditions()    
            self.Start_Master()
            
        if target_ecu.name == "NR1" or target_ecu.name == "NR2"or target_ecu.name == "NR3"or target_ecu.name == "NR4":
            self.ECU_sepecific_preconditions()    
            self.Start_Master()   
            
    def Stop_Ptp(self):
        system("sudo pkill -9 ptp4l")
        logger.info("Stop all ptp4l")

    def Stop_Master(self):
        self.ptp4lProcessMaster.kill()        
        logger.info("kill master")
        sleep(5)
        
    def Stop_Master_inhibit_announce_disabled(self):
        self.ptp4lProcessMaster_inhibit_announce_disabled.kill()        
        logger.info("kill master")
        sleep(5)    
        
    def Stop_Master(self):
        self.ptp4lProcessMaster.kill()        
        logger.info("kill master")
        sleep(5)    

    def Stop_Slave(self):
        self.ptp4lProcessSlave.kill()            
        sleep(5)
        logger.info("kill slave")


    def Start_TestbenchPC_As_Master(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "HCP2" or target_ecu.name == "HCP4":
            self.ECU_sepecific_preconditions()
            self.Start_Master()

    def Start_TestbenchPC_As_Slave(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "HCP2"or target_ecu.name == "HCP4":
            self.ECU_sepecific_preconditions()
            self.Start_Master()
            sleep(3)
            self.Stop_Ptp()
            sleep(2)
            self.Start_Slave()
        if target_ecu.name == "HCP5_100"or target_ecu.name == "HCP5_1000":
            self.Start_Slave()

    def Stop_Ptp_and_PostConditions(self):
        if target_ecu != "MFK_5":
            self.Stop_Ptp()
            self.ECU_sepecific_postconditons()
        if target_ecu == "MFK_5":
            os.system("sudo service ptp4l-master-sim_3 stop")
            self.ECU_sepecific_postconditons()
    def ECU_sepecific_preconditions(self):
        logger.info("target ECU: " + target_ecu.name)
        
        if target_ecu.name == "HCP3"or target_ecu.name=="HCP2" or target_ecu.name == "HCP4" or target_ecu.name == "HCP1"  or target_ecu.name == "PASD"  or target_ecu.name == "NR1"  or target_ecu.name == "NR2"  or target_ecu.name == "NR3" or target_ecu.name == "NR4" or target_ecu.name == "MRR" or target_ecu.name == "ConMOD" or target_ecu.name == "LRR" or target_ecu.name == "MFK_5":
            self.start_cyclic_messages()
        else:
            pass

    def ECU_sepecific_postconditons(self):
        if target_ecu.name == "HCP3" or target_ecu.name == "HCP2" or target_ecu.name == "HCP4"or target_ecu.name == "HCP1" or target_ecu.name == "PASD" or target_ecu.name == "NR1"  or target_ecu.name == "NR2"  or target_ecu.name == "NR3" or target_ecu.name == "NR4" or target_ecu.name == "MRR" or target_ecu.name == "ConMOD" or target_ecu.name == "LRR" or target_ecu.name == "MFK_5":
            self.stop_NM_messages_cyclic()
    

